#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "menu.h"

char author[] = "Michael J. Chappell July 21, 1994";
char *about_[60] = {     "DOSMENU",
                         "Writen by :",
                         "    Michael J. Chappell",
                         " ",
                         "November 5, 1997",
                    };
char *m_s[60];

int  main(int argc, char **argv) {
     FILE *fp;
     int  count, i;
     char temp[256];
     char *pc;
     int  c;
     int  ns = 0, dsel = 1;

     if (argc < 2) help();
     fp = fopen(argv[1], "r");
     if (fp == NULL) exit(0);
     for (count = 0; count < 20; count++) {
          fgets(temp, 58, fp);
          if (pc =  strchr(temp, '\n')) *pc = '\0';
          if (pc == temp) break;
          m_s[count] = malloc(strlen(temp) + 1);
          if (m_s[count] == NULL) exit(0);
          strcpy(m_s[count], temp);
          if (feof(fp)) break;
     }
     fclose(fp);
     INITIALIZE_MENU();
     for (i=2; i<argc; i++) {
          switch (tolower(argv[i][1])) {
               case 't':  
                    ns = atoi(&argv[i][3]);
                    break;
               case 'd':
                    if (isdigit(argv[i][3]))
                         dsel = atoi(&argv[i][3]);
                    else
                         if (ispunct(dsel = argv[i][3]))
                              dsel = argv[i][4] & 31;
                         else
                              dsel = dsel & 31;
                    break;
               case 'c':
                    strcpy(color_dat, &argv[i][3]);
                    break;
          }
     }
     do {
          c = TimedCenterMenu(count-1, m_s, 3, ns, dsel);
          if (c == -1) about();
     } while (c == -1);
     return c;
}

void about(void) {
     CENTER_MENU(4, about_, 3);

     return;
}

void help(void) {
     puts("Michael J. Chappell  November 5, 1997  DOSMENU.EXE");
     puts("\n     This program will return a selection to DOS using\n"
          "ERRORLEVEL, and is useful when creating batch files using menus.");
     puts("\nusage:    DOSMENU filename [/C:colorfile] [/T:ns] [/D:default]\n"
          "          IF ERRORLEVEL n command");
     puts("Where:");
     puts("filename  is the ascii file used to create the menu.  The first\n"
          "             line is the menu title.  The subsequent lines\n"
          "             corespond to the 1st - 20th lines of the menu.");
     puts("colorfile is the binary file containing information on which\n"
          "             colors to use.  The default file is COLOR.DAT.  The\n"
          "             colors default to mono if colorfile is not found.");
     puts("ns        is the number of seconds to wait for a menu\n"
          "             selection. 0 will wait for the user to make a menu\n"
          "             selection, and is the default.");
     puts("default   is the menu selection that's initially highlighted.\n"
          "             Its default is 1.");
     puts("command   is executed if ERRORLEVEL, your selection, is at\n"
          "             least n.");
     puts("n         is the selection to be checked against ERRORLEVEL.");
     exit(0);
} /* help */
